package ims

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// GetAccountMFAInfo invokes the ims.GetAccountMFAInfo API synchronously
func (client *Client) GetAccountMFAInfo(request *GetAccountMFAInfoRequest) (response *GetAccountMFAInfoResponse, err error) {
	response = CreateGetAccountMFAInfoResponse()
	err = client.DoAction(request, response)
	return
}

// GetAccountMFAInfoWithChan invokes the ims.GetAccountMFAInfo API asynchronously
func (client *Client) GetAccountMFAInfoWithChan(request *GetAccountMFAInfoRequest) (<-chan *GetAccountMFAInfoResponse, <-chan error) {
	responseChan := make(chan *GetAccountMFAInfoResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.GetAccountMFAInfo(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// GetAccountMFAInfoWithCallback invokes the ims.GetAccountMFAInfo API asynchronously
func (client *Client) GetAccountMFAInfoWithCallback(request *GetAccountMFAInfoRequest, callback func(response *GetAccountMFAInfoResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *GetAccountMFAInfoResponse
		var err error
		defer close(result)
		response, err = client.GetAccountMFAInfo(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// GetAccountMFAInfoRequest is the request struct for api GetAccountMFAInfo
type GetAccountMFAInfoRequest struct {
	*requests.RpcRequest
	AkProxySuffix string `position:"Query" name:"AkProxySuffix"`
}

// GetAccountMFAInfoResponse is the response struct for api GetAccountMFAInfo
type GetAccountMFAInfoResponse struct {
	*responses.BaseResponse
	RequestId   string `json:"RequestId" xml:"RequestId"`
	IsMFAEnable bool   `json:"IsMFAEnable" xml:"IsMFAEnable"`
}

// CreateGetAccountMFAInfoRequest creates a request to invoke GetAccountMFAInfo API
func CreateGetAccountMFAInfoRequest() (request *GetAccountMFAInfoRequest) {
	request = &GetAccountMFAInfoRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Ims", "2019-08-15", "GetAccountMFAInfo", "ims", "openAPI")
	request.Method = requests.POST
	return
}

// CreateGetAccountMFAInfoResponse creates a response to parse from GetAccountMFAInfo response
func CreateGetAccountMFAInfoResponse() (response *GetAccountMFAInfoResponse) {
	response = &GetAccountMFAInfoResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
